Index: /branches/OMEdit/OMEditGUI/LineAnnotation.cpp
===================================================================
--- /branches/OMEdit/OMEditGUI/LineAnnotation.cpp	(revision 13536)
+++ /branches/OMEdit/OMEditGUI/LineAnnotation.cpp	(revision 13537)
@@ -36,12 +36,12 @@
 #include "LineAnnotation.h"
 
-LineAnnotation_OMC::LineAnnotation_OMC(QString annotation, Component_OMC *pParent)
-  : ShapeAnnotation_OMC(pParent)
+LineAnnotation::LineAnnotation(QString annotation, Component *pParent)
+  : ShapeAnnotation(pParent)
 {
   parseShapeAnnotation(annotation);
 }
 
-LineAnnotation_OMC::LineAnnotation_OMC(Component_OMC *pStartComponent, GraphicsView *pGraphicsView)
-  : ShapeAnnotation_OMC(0)
+LineAnnotation::LineAnnotation(Component *pStartComponent, GraphicsView *pGraphicsView)
+  : ShapeAnnotation(0)
 {
   setZValue(-1.0);
@@ -62,5 +62,5 @@
 }
 
-void LineAnnotation_OMC::parseShapeAnnotation(QString annotation)
+void LineAnnotation::parseShapeAnnotation(QString annotation)
 {
   GraphicItem::parseShapeAnnotation(annotation);
@@ -103,5 +103,5 @@
 }
 
-QPainterPath LineAnnotation_OMC::getShape() const
+QPainterPath LineAnnotation::getShape() const
 {
   QPainterPath path;
@@ -154,10 +154,10 @@
 }
 
-QRectF LineAnnotation_OMC::boundingRect() const
+QRectF LineAnnotation::boundingRect() const
 {
   return shape().boundingRect();
 }
 
-QPainterPath LineAnnotation_OMC::shape() const
+QPainterPath LineAnnotation::shape() const
 {
   QPainterPath path = getShape();
@@ -165,5 +165,5 @@
 }
 
-void LineAnnotation_OMC::paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget)
+void LineAnnotation::paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget)
 {
   Q_UNUSED(option);
@@ -176,5 +176,5 @@
 }
 
-void LineAnnotation_OMC::drawLineAnnotaion(QPainter *painter)
+void LineAnnotation::drawLineAnnotaion(QPainter *painter)
 {
   applyLinePattern(painter);
@@ -202,5 +202,5 @@
 }
 
-QPolygonF LineAnnotation_OMC::drawArrow(QPointF startPos, QPointF endPos, qreal size, int arrowType) const
+QPolygonF LineAnnotation::drawArrow(QPointF startPos, QPointF endPos, qreal size, int arrowType) const
 {
   double xA = size / 2;
@@ -257,5 +257,5 @@
 }
 
-QString LineAnnotation_OMC::getShapeAnnotation()
+QString LineAnnotation::getShapeAnnotation()
 {
   QString annotationString;
@@ -294,25 +294,25 @@
 }
 
-void LineAnnotation_OMC::setStartComponent(Component_OMC *pStartComponent)
+void LineAnnotation::setStartComponent(Component *pStartComponent)
 {
   mpStartComponent = pStartComponent;
 }
 
-Component_OMC* LineAnnotation_OMC::getStartComponent()
+Component* LineAnnotation::getStartComponent()
 {
   return mpStartComponent;
 }
 
-void LineAnnotation_OMC::setEndComponent(Component_OMC *pEndComponent)
+void LineAnnotation::setEndComponent(Component *pEndComponent)
 {
   mpEndComponent = pEndComponent;
 }
 
-Component_OMC* LineAnnotation_OMC::getEndComponent()
+Component* LineAnnotation::getEndComponent()
 {
   return mpEndComponent;
 }
 
-void LineAnnotation_OMC::addPoint(QPointF point)
+void LineAnnotation::addPoint(QPointF point)
 {
   //! @todo make it better
@@ -320,33 +320,33 @@
   if(mPoints.size() <= 2 && (fabs(mpStartComponent->getTransformation()->getRotateAngle()) >= 0 && fabs(mpStartComponent->getTransformation()->getRotateAngle()) < 90))
   {
-    mGeometries.push_back(LineAnnotation_OMC::HORIZONTAL);
+    mGeometries.push_back(LineAnnotation::HORIZONTAL);
   }
   else if(mPoints.size() <= 2 && (fabs(mpStartComponent->getTransformation()->getRotateAngle()) >= 90 && fabs(mpStartComponent->getTransformation()->getRotateAngle()) < 180))
   {
-    mGeometries.push_back(LineAnnotation_OMC::VERTICAL);
+    mGeometries.push_back(LineAnnotation::VERTICAL);
   }
   else if(mPoints.size() <= 2 && (fabs(mpStartComponent->getTransformation()->getRotateAngle()) >= 180 && fabs(mpStartComponent->getTransformation()->getRotateAngle()) < 270))
   {
-    mGeometries.push_back(LineAnnotation_OMC::HORIZONTAL);
+    mGeometries.push_back(LineAnnotation::HORIZONTAL);
   }
   else if(mPoints.size() <= 2 && (fabs(mpStartComponent->getTransformation()->getRotateAngle()) >= 270 && fabs(mpStartComponent->getTransformation()->getRotateAngle()) < 360))
   {
-    mGeometries.push_back(LineAnnotation_OMC::VERTICAL);
+    mGeometries.push_back(LineAnnotation::VERTICAL);
   }
   else if (mPoints.size() <= 2)
   {
-    mGeometries.push_back(LineAnnotation_OMC::HORIZONTAL);
-  }
-  else if(mPoints.size() > 2 && mGeometries.back() == LineAnnotation_OMC::HORIZONTAL)
-  {
-    mGeometries.push_back(LineAnnotation_OMC::VERTICAL);
-  }
-  else if(mPoints.size() > 2 && mGeometries.back() == LineAnnotation_OMC::VERTICAL)
-  {
-    mGeometries.push_back(LineAnnotation_OMC::HORIZONTAL);
-  }
-  else if(mPoints.size() > 2 && mGeometries.back() == LineAnnotation_OMC::DIAGONAL)
-  {
-    mGeometries.push_back(LineAnnotation_OMC::DIAGONAL);
+    mGeometries.push_back(LineAnnotation::HORIZONTAL);
+  }
+  else if(mPoints.size() > 2 && mGeometries.back() == LineAnnotation::HORIZONTAL)
+  {
+    mGeometries.push_back(LineAnnotation::VERTICAL);
+  }
+  else if(mPoints.size() > 2 && mGeometries.back() == LineAnnotation::VERTICAL)
+  {
+    mGeometries.push_back(LineAnnotation::HORIZONTAL);
+  }
+  else if(mPoints.size() > 2 && mGeometries.back() == LineAnnotation::DIAGONAL)
+  {
+    mGeometries.push_back(LineAnnotation::DIAGONAL);
     //Give new line correct angle!
   }
@@ -356,5 +356,5 @@
 //! @param point is the new start point.
 //! @see updateEndPoint(QPointF point)
-void LineAnnotation_OMC::updateStartPoint(QPointF point)
+void LineAnnotation::updateStartPoint(QPointF point)
 {
   if (mPoints.size() == 0)
@@ -364,21 +364,21 @@
   if (mPoints.size() != 1)
   {
-    if (mGeometries[0] == LineAnnotation_OMC::HORIZONTAL)
+    if (mGeometries[0] == LineAnnotation::HORIZONTAL)
       mPoints[1] = QPointF(mPoints[1].x(),mPoints[0].y());
-    else if (mGeometries[0] == LineAnnotation_OMC::VERTICAL)
+    else if (mGeometries[0] == LineAnnotation::VERTICAL)
       mPoints[1] = QPointF(mPoints[0].x(),mPoints[1].y());
   }
 }
 
-void LineAnnotation_OMC::updateEndPoint(QPointF point)
+void LineAnnotation::updateEndPoint(QPointF point)
 {
   mPoints.back() = point;
-  if (mGeometries.back() == LineAnnotation_OMC::HORIZONTAL)
+  if (mGeometries.back() == LineAnnotation::HORIZONTAL)
     mPoints[mPoints.size()-2] = QPointF(mPoints[mPoints.size()-2].x(),point.y());
-  else if (mGeometries.back() == LineAnnotation_OMC::VERTICAL)
+  else if (mGeometries.back() == LineAnnotation::VERTICAL)
     mPoints[mPoints.size()-2] = QPointF(point.x(),mPoints[mPoints.size()-2].y());
 }
 
-void LineAnnotation_OMC::moveAllPoints(qreal offsetX, qreal offsetY)
+void LineAnnotation::moveAllPoints(qreal offsetX, qreal offsetY)
 {
   for(int i=0; i != mPoints.size(); ++i)
@@ -388,5 +388,25 @@
 }
 
-void LineAnnotation_OMC::handleComponentMoved()
+void LineAnnotation::setStartComponentName(QString name)
+{
+  mStartComponentName = name;
+}
+
+QString LineAnnotation::getStartComponentName()
+{
+  return mStartComponentName;
+}
+
+void LineAnnotation::setEndComponentName(QString name)
+{
+  mEndComponentName = name;
+}
+
+QString LineAnnotation::getEndComponentName()
+{
+  return mEndComponentName;
+}
+
+void LineAnnotation::handleComponentMoved()
 {
   if (mPoints.size() < 2)
@@ -406,402 +426,132 @@
 }
 
-void LineAnnotation_OMC::updateConnectionAnnotation()
+void LineAnnotation::updateConnectionAnnotation()
 {
   // get the connection line annotation.
   QString annotationString = QString("annotate=").append(getShapeAnnotation());
-  // get the connected components names.
-  QString startComponentName, endComponentName;
-  if (mpStartComponent->getParentComponent())
-    startComponentName = QString(mpStartComponent->getParentComponent()->getName()).append(".").append(mpStartComponent->getComponentInfo()->getName());
-  else
-    startComponentName = mpStartComponent->getName();
-  if (mpEndComponent->getParentComponent())
-    endComponentName = QString(mpEndComponent->getParentComponent()->getName()).append(".").append(mpEndComponent->getComponentInfo()->getName());
-  else
-    endComponentName = mpEndComponent->getName();
   // update the connection
   OMCProxy *pOMCProxy = mpGraphicsView->getModelWidget()->getModelWidgetContainer()->getMainWindow()->getOMCProxy();
-  pOMCProxy->updateConnection(startComponentName, endComponentName, mpGraphicsView->getModelWidget()->getLibraryTreeNode()->getNameStructure(), annotationString);
-}
-
-
-
-LineAnnotation::LineAnnotation(QString shape, Component *pParent)
-  : ShapeAnnotation(pParent), mpComponent(pParent)
-{
-  // initialize all fields with default values
-  initializeFields();
-  parseShapeAnnotation(shape);
-}
-
-LineAnnotation::LineAnnotation(GraphicsView *graphicsView, QGraphicsItem *pParent)
-  : ShapeAnnotation(graphicsView, pParent)
-{
-  // initialize all fields with default values
-  initializeFields();
-  mIsCustomShape = true;
-  setAcceptHoverEvents(true);
-  connect(this, SIGNAL(updateShapeAnnotation()), mpGraphicsView, SLOT(addClassAnnotation()));
-}
-
-LineAnnotation::LineAnnotation(QString shape, GraphicsView *graphicsView, QGraphicsItem *pParent)
-  : ShapeAnnotation(graphicsView, pParent)
-{
-  // initialize all fields with default values
-  initializeFields();
-  parseShapeAnnotation(shape);
-  mIsCustomShape = true;
-  setAcceptHoverEvents(true);
-  connect(this, SIGNAL(updateShapeAnnotation()), mpGraphicsView, SLOT(addClassAnnotation()));
-}
-
-QPainterPath LineAnnotation::getShape() const
-{
-  QPainterPath path;
-
-  if (this->mPoints.size() > 0)
-  {
-    if (mSmooth)
+  pOMCProxy->updateConnection(getStartComponentName(), getEndComponentName(),
+                              mpGraphicsView->getModelWidget()->getLibraryTreeNode()->getNameStructure(), annotationString);
+}
+
+ConnectionArray::ConnectionArray(GraphicsView *pGraphicsView, LineAnnotation *pConnectionLineAnnotation, QWidget *pParent)
+  : QDialog(pParent, Qt::WindowTitleHint), mpGraphicsView(pGraphicsView), mpConnectionLineAnnotation(pConnectionLineAnnotation)
+{
+  setWindowTitle(QString(Helper::applicationName).append(" - ").append(Helper::connectArray));
+  setAttribute(Qt::WA_DeleteOnClose);
+  setMinimumSize(375, 140);
+  setModal(true);
+  // heading
+  mpHeading = new Label(Helper::connectArray);
+  mpHeading->setFont(QFont("", Helper::headingFontSize));
+  mpHeading->setAlignment(Qt::AlignTop);
+  // horizontal line
+  mpHorizontalLine = new QFrame();
+  mpHorizontalLine->setFrameShape(QFrame::HLine);
+  mpHorizontalLine->setFrameShadow(QFrame::Sunken);
+  // Description text
+  QString startComponentDescription = QString("<b>").append(pConnectionLineAnnotation->getStartComponent()->getParentComponent()->getName())
+      .append(".").append(pConnectionLineAnnotation->getStartComponent()->getName()).append("</b>");
+  if (pConnectionLineAnnotation->getStartComponent()->getComponentInfo()->isArray())
+    startComponentDescription.append("<b>[index]</b>");
+  QString endComponentDescription = QString("<b>").append(pConnectionLineAnnotation->getEndComponent()->getParentComponent()->getName())
+      .append(".").append(pConnectionLineAnnotation->getEndComponent()->getName()).append("</b>");
+  if (pConnectionLineAnnotation->getEndComponent()->getComponentInfo()->isArray())
+    endComponentDescription.append("<b>[index]</b>");
+  mpDescriptionLabel = new Label(QString("Connect ").append(startComponentDescription).append(" with ").append(endComponentDescription));
+  // start component
+  QIntValidator *pIntValidator = new QIntValidator(this);
+  pIntValidator->setBottom(0);
+  mpStartComponentLabel = new Label(tr("Enter <b>index</b> value for <b>").append(pConnectionLineAnnotation->getStartComponent()->getParentComponent()->getName())
+                                    .append(".").append(pConnectionLineAnnotation->getStartComponent()->getName()).append("<b>"));
+  mpStartComponentTextBox = new QLineEdit;
+  mpStartComponentTextBox->setValidator(pIntValidator);
+  // start component
+  mpEndComponentLabel = new Label(tr("Enter <b>index</b> value for <b>").append(pConnectionLineAnnotation->getEndComponent()->getParentComponent()->getName())
+                                  .append(".").append(pConnectionLineAnnotation->getEndComponent()->getComponentInfo()->getName()).append("</b>"));
+  mpEndComponentTextBox = new QLineEdit;
+  mpEndComponentTextBox->setValidator(pIntValidator);
+  // Create the buttons
+  mpOkButton = new QPushButton(Helper::ok);
+  mpOkButton->setAutoDefault(true);
+  connect(mpOkButton, SIGNAL(clicked()), SLOT(saveArrayIndex()));
+  mpCancelButton = new QPushButton(Helper::cancel);
+  mpCancelButton->setAutoDefault(false);
+  connect(mpCancelButton, SIGNAL(clicked()), SLOT(cancelArrayIndex()));
+  // add buttons
+  mpButtonBox = new QDialogButtonBox(Qt::Horizontal);
+  mpButtonBox->addButton(mpOkButton, QDialogButtonBox::ActionRole);
+  mpButtonBox->addButton(mpCancelButton, QDialogButtonBox::ActionRole);
+  // Create a layout
+  QGridLayout *mainLayout = new QGridLayout;
+  mainLayout->addWidget(mpHeading, 0, 0);
+  mainLayout->addWidget(mpHorizontalLine, 1, 0);
+  mainLayout->addWidget(mpDescriptionLabel, 2, 0);
+  int i = 3;
+  if (pConnectionLineAnnotation->getStartComponent()->getComponentInfo()->isArray())
+  {
+    mainLayout->addWidget(mpStartComponentLabel, i, 0);
+    mainLayout->addWidget(mpStartComponentTextBox, i+1, 0);
+    i = i + 2;
+  }
+  if (pConnectionLineAnnotation->getEndComponent()->getComponentInfo()->isArray())
+  {
+    mainLayout->addWidget(mpEndComponentLabel, i, 0);
+    mainLayout->addWidget(mpEndComponentTextBox, i+1, 0);
+    i = i + 2;
+  }
+  mainLayout->addWidget(mpButtonBox, i, 0);
+  setLayout(mainLayout);
+}
+
+void ConnectionArray::saveArrayIndex()
+{
+  QString startComponentName, endComponentName;
+  // set start component name
+  if (mpConnectionLineAnnotation->getStartComponent()->getComponentInfo()->isArray())
+  {
+    startComponentName = QString(mpConnectionLineAnnotation->getStartComponent()->getParentComponent()->getName()).append(".")
+        .append(mpConnectionLineAnnotation->getStartComponent()->getName());
+    if (mpStartComponentTextBox->text().isEmpty())
     {
-      for (int i = 0 ; i < this->mPoints.size() ; i++)
-      {
-        QPointF point3 = this->mPoints.at(i);
-        if (i == 0)
-          path.moveTo(point3);
-        else
-        {
-          // if points are only two then spline acts as simple line
-          if (i < 2)
-          {
-            if (mPoints.size() < 3)
-              path.lineTo(point3);
-          }
-          else
-          {
-            // calculate middle points for bezier curves
-            QPointF point2 = this->mPoints.at(i - 1);
-            QPointF point1 = this->mPoints.at(i - 2);
-            QPointF point12((point1.x() + point2.x())/2, (point1.y() + point2.y())/2);
-            QPointF point23((point2.x() + point3.x())/2, (point2.y() + point3.y())/2);
-
-            path.lineTo(point12);
-            path.cubicTo(point12, point2, point23);
-            // if its the last point
-            if (i == mPoints.size() - 1)
-              path.lineTo(point3);
-          }
-        }
-      }
-    }
-    else
-    {
-      for (int i = 0 ; i < this->mPoints.size() ; i++)
-      {
-        QPointF point1 = this->mPoints.at(i);
-        if (i == 0)
-          path.moveTo(point1);
-        else
-          path.lineTo(point1);
-      }
-    }
-  }
-  return path;
-}
-
-QRectF LineAnnotation::boundingRect() const
-{
-  return shape().boundingRect();
-}
-
-QPainterPath LineAnnotation::shape() const
-{
-  QPainterPath path = getShape();
-  return addPathStroker(path);
-}
-
-void LineAnnotation::paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget)
-{
-  Q_UNUSED(option);
-  Q_UNUSED(widget);
-
-  if (transformOriginPoint() != boundingRect().center())
-  {
-    setTransformOriginPoint(boundingRect().center());
-  }
-  drawLineAnnotaion(painter);
-}
-
-void LineAnnotation::drawLineAnnotaion(QPainter *painter)
-{
-  qreal thickness;
-
-  // make the pen width upper rounded for spline, otherwise spline is distorted
-  thickness = ceil(mThickness);
-  // this is commented intentionally so that we dont need path stroker. Also helps in svg rendering
-  //    if (mSmooth)
-  //        thickness = ceil(mThickness);
-  //    else
-  //        thickness = mThickness;
-
-  QPen pen(this->mLineColor, thickness, this->mLinePattern);
-  pen.setCosmetic(true);
-  painter->setPen(pen);
-  // draw start arrow
-  if (mStartArrow == ShapeAnnotation::Filled)
-  {
-    painter->save();
-    painter->setBrush(QBrush(mLineColor, Qt::SolidPattern));
-    painter->drawPolygon(drawArrow(mPoints.at(0), mPoints.at(1), mArrowSize * 2, mStartArrow));
-    painter->restore();
-  }
-  else
-    painter->drawPolygon(drawArrow(mPoints.at(0), mPoints.at(1), mArrowSize * 2, mStartArrow));
-
-  painter->drawPath(getShape());
-
-  // draw end arrow
-  if (mEndArrow == ShapeAnnotation::Filled)
-  {
-    painter->save();
-    painter->setBrush(QBrush(mLineColor, Qt::SolidPattern));
-    painter->drawPolygon(drawArrow(mPoints.at(mPoints.size() - 1), mPoints.at(mPoints.size() - 2),
-                                   mArrowSize * 2, mEndArrow));
-    painter->restore();
-  }
-  else
-    painter->drawPolygon(drawArrow(mPoints.at(mPoints.size() - 1), mPoints.at(mPoints.size() - 2),
-                                   mArrowSize * 2, mEndArrow));
-}
-
-void LineAnnotation::addPoint(QPointF point)
-{
-  mPoints.append(point);
-}
-
-void LineAnnotation::updateEndPoint(QPointF point)
-{
-  mPoints.back() = point;
-}
-
-void LineAnnotation::drawRectangleCornerItems()
-{
-  mIsFinishedCreatingShape = true;
-  // remove the last point since mouse double click event has added an extra point to it.....
-  mPoints.remove(mPoints.size() - 1);
-  for (int i = 0 ; i < this->mPoints.size() ; i++)
-  {
-    QPointF point = this->mPoints.at(i);
-    RectangleCornerItem *rectangleCornerItem = new RectangleCornerItem(point.x(), point.y(), i, this);
-    mRectangleCornerItemsList.append(rectangleCornerItem);
-  }
-  emit updateShapeAnnotation();
-}
-
-QString LineAnnotation::getShapeAnnotation()
-{
-  QString annotationString;
-  annotationString.append("Line(");
-
-  if (!mVisible)
-  {
-    annotationString.append("visible=false,");
-  }
-
-  annotationString.append("points={");
-  for (int i = 0 ; i < mPoints.size() ; i++)
-  {
-    annotationString.append("{").append(QString::number(mapToScene(mPoints[i]).x())).append(",");
-    annotationString.append(QString::number(mapToScene(mPoints[i]).y())).append("}");
-    if (i < mPoints.size() - 1)
-      annotationString.append(",");
-  }
-  annotationString.append("},");
-
-  annotationString.append("rotation=").append(QString::number(this->rotation())).append(",");
-
-  annotationString.append("color={");
-  annotationString.append(QString::number(mLineColor.red())).append(",");
-  annotationString.append(QString::number(mLineColor.green())).append(",");
-  annotationString.append(QString::number(mLineColor.blue()));
-  annotationString.append("},");
-
-  QMap<QString, Qt::PenStyle>::iterator it;
-  for (it = this->mLinePatternsMap.begin(); it != this->mLinePatternsMap.end(); ++it)
-  {
-    if (it.value() == mLinePattern)
-    {
-      annotationString.append("pattern=LinePattern.").append(it.key()).append(",");
-      break;
-    }
-  }
-
-  annotationString.append("thickness=").append(QString::number(mThickness));
-  if (mSmooth)
-  {
-    annotationString.append(",smooth=Smooth.Bezier");
-  }
-
-  annotationString.append(")");
-  return annotationString;
-}
-
-void LineAnnotation::updatePoint(int index, QPointF point)
-{
-  mPoints.replace(index, point);
-}
-
-void LineAnnotation::parseShapeAnnotation(QString shape)
-{
-  // parse the shape to get the list of attributes of Line.
-  QStringList list = StringHandler::getStrings(shape);
-  if (list.size() < 8)
-  {
-    return;
-  }
-
-  // if first item of list is true then the Line should be visible.
-  this->mVisible = static_cast<QString>(list.at(0)).contains("true");
-
-  int index = 0;
-  QStringList originList = StringHandler::getStrings(StringHandler::removeFirstLastCurlBrackets(list.at(1)));
-  mOrigin.setX(static_cast<QString>(originList.at(0)).toFloat());
-  mOrigin.setY(static_cast<QString>(originList.at(1)).toFloat());
-  mRotation = static_cast<QString>(list.at(2)).toFloat();
-  index = 2;
-  // second item of list contains the points.
-  index = index + 1;
-  QStringList pointsList = StringHandler::getStrings(StringHandler::removeFirstLastCurlBrackets(list.at(index)));
-
-  foreach (QString point, pointsList)
-  {
-    QStringList linePoints = StringHandler::getStrings(StringHandler::removeFirstLastCurlBrackets(point));
-    if (linePoints.size() < 2)
-    {
+      QMessageBox::critical(mpGraphicsView->getModelWidget()->getModelWidgetContainer()->getMainWindow(),
+                            QString(Helper::applicationName).append(" - ").append(Helper::error),
+                            GUIMessages::getMessage(GUIMessages::ENTER_VALID_INTEGER).arg(startComponentName), Helper::ok);
       return;
     }
-
-    qreal x = static_cast<QString>(linePoints.at(0)).toFloat();
-    qreal y = static_cast<QString>(linePoints.at(1)).toFloat();
-    QPointF p (x, y);
-    this->mPoints.append(p);
-  }
-
-  // third item of list contains the color.
-  index = index + 1;
-  QStringList colorList = StringHandler::getStrings(StringHandler::removeFirstLastCurlBrackets(list.at(index)));
-  if (colorList.size() < 3)
-  {
-    return;
-  }
-
-  int red = static_cast<QString>(colorList.at(0)).toInt();
-  int green = static_cast<QString>(colorList.at(1)).toInt();
-  int blue = static_cast<QString>(colorList.at(2)).toInt();
-
-  this->mLineColor = QColor (red, green, blue);
-
-  // fourth item of list contains the Line Pattern.
-  index = index + 1;
-  QString linePattern = StringHandler::getLastWordAfterDot(list.at(index));
-  QMap<QString, Qt::PenStyle>::iterator it;
-  for (it = this->mLinePatternsMap.begin(); it != this->mLinePatternsMap.end(); ++it)
-  {
-    if (it.key().compare(linePattern) == 0)
+    startComponentName = QString(startComponentName).append("[").append(mpStartComponentTextBox->text()).append("]");
+  }
+  else
+  {
+    startComponentName = QString(mpConnectionLineAnnotation->getStartComponent()->getParentComponent()->getName()).append(".")
+        .append(mpConnectionLineAnnotation->getStartComponent()->getName());
+  }
+  // set end component name
+  if (mpConnectionLineAnnotation->getEndComponent()->getComponentInfo()->isArray())
+  {
+    endComponentName = QString(mpConnectionLineAnnotation->getEndComponent()->getParentComponent()->getName()).append(".")
+        .append(mpConnectionLineAnnotation->getEndComponent()->getName());
+    if (mpEndComponentTextBox->text().isEmpty())
     {
-      this->mLinePattern = it.value();
-      break;
+      QMessageBox::critical(mpGraphicsView->getModelWidget()->getModelWidgetContainer()->getMainWindow(),
+                            QString(Helper::applicationName).append(" - ").append(Helper::error),
+                            GUIMessages::getMessage(GUIMessages::ENTER_VALID_INTEGER).arg(endComponentName), Helper::ok);
+      return;
     }
-  }
-
-  // fifth item of list contains the Line thickness.
-  index = index + 1;
-  this->mThickness = static_cast<QString>(list.at(index)).toFloat();
-
-  // sixth item of list contains the Line Arrows.
-  index = index + 1;
-  QStringList arrowList = StringHandler::getStrings(StringHandler::removeFirstLastCurlBrackets(list.at(index)));
-  if (arrowList.size() < 2)
-    return;
-
-  QMap<QString, ArrowType>::iterator arrow_it;
-  for (arrow_it = mArrowsMap.begin(); arrow_it != mArrowsMap.end(); ++arrow_it)
-  {
-    if (arrow_it.key().compare(StringHandler::getLastWordAfterDot(arrowList.at(0))) == 0)
-      mStartArrow = arrow_it.value();
-    if (arrow_it.key().compare(StringHandler::getLastWordAfterDot(arrowList.at(1))) == 0)
-      mEndArrow = arrow_it.value();
-  }
-
-  // seventh item of list contains the Line Arrow Size.
-  index = index + 1;
-  mArrowSize = static_cast<QString>(list.at(index)).toFloat();
-
-  // eighth item of list contains the smooth.
-  index = index + 1;
-  this->mSmooth = static_cast<QString>(list.at(index)).toLower().contains("smooth.bezier");
-}
-
-QPolygonF LineAnnotation::drawArrow(QPointF startPos, QPointF endPos, qreal size, int arrowType) const
-{
-  double xA = size / 2;
-  double yA = size * sqrt(3) / 2;
-
-  double xB = -xA;
-  double yB = yA;
-
-  switch (arrowType)
-  {
-    case ShapeAnnotation::Filled:
-      break;
-    case ShapeAnnotation::Half:
-      xB = 0;
-      break;
-    case ShapeAnnotation::None:
-      return QPolygonF();
-    case ShapeAnnotation::Open:
-      break;
-  }
-
-  double angle = 0.0f;
-  if (endPos.x() - startPos.x() == 0)
-  {
-    if (endPos.y() - startPos.y() >= 0)
-      angle = 0;
-    else
-      angle = M_PI;
-  }
-  else
-  {
-    angle = -(M_PI / 2 - (atan((endPos.y() - startPos.y())/(endPos.x() - startPos.x()))));
-    if(startPos.x() > endPos.x())
-      angle += M_PI;
-  }
-
-  qreal m11, m12, m13, m21, m22, m23, m31, m32, m33;
-
-  m11 = cos(angle);
-  m12 = -sin(angle);
-  m13 = startPos.x();
-  m21 = sin(angle);
-  m22 = cos(angle);
-  m23 = startPos.y();
-  m31 = 0;
-  m32 = 0;
-  m33 = 1;
-
-  QTransform t1(m11, m12, m13, m21, m22, m23, m31, m32, m33);
-  QTransform t2(xA, 1, 1, yA, 1, 1, 1, 1, 1);
-  QTransform t3 = t1 * t2;
-
-  QPolygonF polygon;
-  polygon << startPos;
-  polygon << QPointF(t3.m11(), t3.m21());
-
-  t2.setMatrix(xB, 1, 1, yB, 1, 1, 1, 1, 1);
-  t3 = t1 * t2;
-
-  polygon << QPointF(t3.m11(), t3.m21());
-  polygon << startPos;
-
-  return polygon;
-}
+    endComponentName = QString(endComponentName).append("[").append(mpEndComponentTextBox->text()).append("]");
+  }
+  else
+  {
+    endComponentName = QString(mpConnectionLineAnnotation->getEndComponent()->getParentComponent()->getName()).append(".")
+        .append(mpConnectionLineAnnotation->getEndComponent()->getName());
+  }
+  mpGraphicsView->createConnection(startComponentName, endComponentName);
+  accept();
+}
+
+void ConnectionArray::cancelArrayIndex()
+{
+  mpGraphicsView->removeConnection();
+  reject();
+}
Index: /branches/OMEdit/OMEditGUI/LineAnnotation.h
===================================================================
--- /branches/OMEdit/OMEditGUI/LineAnnotation.h	(revision 13536)
+++ /branches/OMEdit/OMEditGUI/LineAnnotation.h	(revision 13537)
@@ -42,13 +42,13 @@
 class RectangleCornerItem;
 class ShapeAnnotation;
-class Component_OMC;
+class Component;
 
-class LineAnnotation_OMC : public ShapeAnnotation_OMC
+class LineAnnotation : public ShapeAnnotation
 {
   Q_OBJECT
 public:
   enum geometryType {VERTICAL, HORIZONTAL, DIAGONAL};
-  LineAnnotation_OMC(QString annotation, Component_OMC *pParent);
-  LineAnnotation_OMC(Component_OMC *pStartComponent, GraphicsView *pGraphicsView);
+  LineAnnotation(QString annotation, Component *pParent);
+  LineAnnotation(Component *pStartComponent, GraphicsView *pGraphicsView);
   void parseShapeAnnotation(QString annotation);
   QPainterPath getShape() const;
@@ -59,18 +59,24 @@
   QPolygonF drawArrow(QPointF startPos, QPointF endPos, qreal size, int arrowType) const;
   QString getShapeAnnotation();
-  void setStartComponent(Component_OMC *pStartComponent);
-  Component_OMC* getStartComponent();
-  void setEndComponent(Component_OMC *pEndComponent);
-  Component_OMC* getEndComponent();
+  void setStartComponent(Component *pStartComponent);
+  Component* getStartComponent();
+  void setEndComponent(Component *pEndComponent);
+  Component* getEndComponent();
   void addPoint(QPointF point);
   void updateStartPoint(QPointF point);
   void updateEndPoint(QPointF point);
   void moveAllPoints(qreal offsetX, qreal offsetY);
+  void setStartComponentName(QString name);
+  QString getStartComponentName();
+  void setEndComponentName(QString name);
+  QString getEndComponentName();
 private:
   QList<StringHandler::Arrow> mArrow;
   qreal mArrowSize;
   GraphicsView *mpGraphicsView;
-  Component_OMC *mpStartComponent;
-  Component_OMC *mpEndComponent;
+  Component *mpStartComponent;
+  QString mStartComponentName;
+  Component *mpEndComponent;
+  QString mEndComponentName;
   QList<geometryType> mGeometries;
 public slots:
@@ -79,27 +85,25 @@
 };
 
-
-class LineAnnotation : public ShapeAnnotation
+class ConnectionArray : public QDialog
 {
   Q_OBJECT
 public:
-  LineAnnotation(QString shape, Component *pParent);
-  LineAnnotation(GraphicsView *graphicsView, QGraphicsItem *pParent = 0);
-  LineAnnotation(QString shape, GraphicsView *graphicsView, QGraphicsItem *pParent = 0);
-  QPainterPath getShape() const;
-  QRectF boundingRect() const;
-  QPainterPath shape() const;
-  void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget = 0);
-  void drawLineAnnotaion(QPainter *painter);
-  void addPoint(QPointF point);
-  void updateEndPoint(QPointF point);
-  void drawRectangleCornerItems();
-  QString getShapeAnnotation();
-  void parseShapeAnnotation(QString annotation);
-  QPolygonF drawArrow(QPointF startPos, QPointF endPos, qreal size, int arrowType) const;
-
-  Component *mpComponent;
+  ConnectionArray(GraphicsView *pGraphicsView, LineAnnotation *pConnectionLineAnnotation, QWidget *pParent = 0);
+private:
+  GraphicsView *mpGraphicsView;
+  LineAnnotation *mpConnectionLineAnnotation;
+  Label *mpHeading;
+  QFrame *mpHorizontalLine;
+  Label *mpDescriptionLabel;
+  Label *mpStartComponentLabel;
+  QLineEdit *mpStartComponentTextBox;
+  Label *mpEndComponentLabel;
+  QLineEdit *mpEndComponentTextBox;
+  QPushButton *mpOkButton;
+  QPushButton *mpCancelButton;
+  QDialogButtonBox *mpButtonBox;
 public slots:
-  void updatePoint(int index, QPointF point);
+  void saveArrayIndex();
+  void cancelArrayIndex();
 };
 
